#ifndef __INITIATOR_H
#define __INITIATOR_H

#include <systemc.h>
#include "tlm.h"

SC_MODULE( Initiator ), tlm::tlm_bw_transport_if<>
{
public:
    tlm::tlm_initiator_socket<32> i_socket;

    SC_HAS_PROCESS( Initiator );
    Initiator( sc_module_name name );

protected: 
    // process functions
    void thread0();

    // I/F functions
    virtual tlm::tlm_sync_enum nb_transport_bw(
            tlm::tlm_generic_payload& trans, tlm::tlm_phase &phase, sc_time& time );
    virtual void invalidate_direct_mem_ptr( sc_dt::uint64 a, sc_dt::uint64 b);

    // support functions
    void write( unsigned int addr, unsigned int data, sc_time time=SC_ZERO_TIME );
    void read( unsigned int addr, unsigned int& data, sc_time time=SC_ZERO_TIME );
};

#endif /* __INITIATOR_H_ */
