#ifndef __TARGET_H_
#define __TARGET_H_

#include <systemc.h>
#include "tlm.h"

SC_MODULE( Target ), tlm::tlm_fw_transport_if<>
{
public: 
    tlm::tlm_target_socket<32> t_socket;

    SC_HAS_PROCESS( Target );
    Target( sc_module_name name );
    ~Target();

protected:
    virtual void b_transport( tlm::tlm_generic_payload &trans, sc_time &time ) ;
    virtual tlm::tlm_sync_enum nb_transport_fw( tlm::tlm_generic_payload
            &trans, tlm::tlm_phase &phase, sc_time &time );
    virtual unsigned int transport_dbg( tlm::tlm_generic_payload &trans );
    virtual bool get_direct_mem_ptr( tlm::tlm_generic_payload &trans, tlm::tlm_dmi& dmi);

private:
    enum { REG_SIZE = 256 };
    unsigned int *Reg;
};

#endif  /* __TARGET_H_ */
